%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [q0,edof,emat,bc,F_ext,mat,ndim,nel,node,ndof,nip,nlod] = ex_henry
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% this is henry's own bone
% scaled to deltaX = 81.8519, deltaY = 90 by dividing geometry by 2.7
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
emod = 37.90d0; % [N/mm^2]
nue  = 0.3d0;   % [-]
rho0 = 1.00d0;  % [g/cm^3]
psi0 = 0.0000275d0; % [mm scale]
expm = 3.0d0;   % [-]
expn = 2.0d0;   % [-]
dt   = 5.0d0;   % [s]

mat = [emod,nue,rho0,psi0,expm,expn,dt];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% generate node points q0 and connectivity edof
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[q0,edof]=in_henry;
 q0 = q0 / 2.7; %[mm]          % scale to deltaX = 81.8519, deltaY = 90

[nel,sizen]  = size(edof);
[ndof,sizen] = size(q0);
 
 for ie=1:nel emat(ie) = 1; end;
 
 node = ndof/2;
 nip  = 1;
 ndim = 2;
 tol  =  1e-8;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% dirichlet boundary conditions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
bc(  1,1) = 2* 171;     bc( 1,2) = 0;   % fix node 171 in y-dir
bc(  2,1) = 2* 183;     bc( 2,2) = 0;   % fix node 183 in y-dir
bc(  3,1) = 2* 192;     bc( 3,2) = 0;   % fix node 192 in y-dir
bc(  4,1) = 2* 205;     bc( 4,2) = 0;   % fix node 205 in y-dir
bc(  5,1) = 2* 221;     bc( 5,2) = 0;   % fix node 221 in y-dir
bc(  6,1) = 2* 238;     bc( 6,2) = 0;   % fix node 238 in y-dir
bc(  7,1) = 2* 262;     bc( 7,2) = 0;   % fix node 262 in y-dir
bc(  8,1) = 2* 289;     bc( 8,2) = 0;   % fix node 289 in y-dir
bc(  9,1) = 2* 318;     bc( 9,2) = 0;   % fix node 318 in y-dir
bc( 10,1) = 2* 341;     bc(10,2) = 0;   % fix node 341 in y-dir
bc( 11,1) = 2* 368;     bc(11,2) = 0;   % fix node 368 in y-dir
bc( 12,1) = 2* 390;     bc(12,2) = 0;   % fix node 390 in y-dir
bc( 13,1) = 2* 423;     bc(13,2) = 0;   % fix node 423 in y-dir
bc( 14,1) = 2* 456;     bc(14,2) = 0;   % fix node 456 in y-dir
bc( 15,1) = 2* 486;     bc(15,2) = 0;   % fix node 486 in y-dir
bc( 16,1) = 2* 519;     bc(16,2) = 0;   % fix node 519 in y-dir
bc( 17,1) = 2* 551;     bc(17,2) = 0;   % fix node 551 in y-dir
bc( 18,1) = 2* 583;     bc(18,2) = 0;   % fix node 583 in y-dir
bc( 19,1) = 2* 613;     bc(19,2) = 0;   % fix node 613 in y-dir
bc( 20,1) = 2* 641-1;   bc(20,2) = 0;   % fix node 641 in x-dir
bc( 21,1) = 2* 641;     bc(21,2) = 0;   % fix node 641 in y-dir

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% neumann boundary conditions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
F_ext = zeros(ndof,1);
nlod = 5;

 F_fac =560.d0; % maximum force
 F_scl = 1/nlod;
 F_ext(668*2-1)= 5.d0/110.0d0*F_fac*F_scl; % medial  - horizontal
 F_ext(668*2  )=-6.d0/ 11.0d0*F_fac*F_scl; % medial  - vertical
 F_ext(248*2-1)=-5.d0/110.0d0*F_fac*F_scl; % lateral - horizontal
 F_ext(248*2  )=-5.d0/ 11.0d0*F_fac*F_scl; % lateral - vertical
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[nmat,ngrw] = size(mat);
if (ngrw==7); disp('*** density growth ***'); end;  % density
if (ngrw==9); disp('*** volume growth ***' ); end;  % volume
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%