%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [q0,edof,emat,bc,F_ext,mat,ndim,nel,node,ndof,nip,nlod] = ex_henry
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
emod = 500;
nue  = 0.2;
rho0 = 1.00;
psi0 = 0.01;
expm = 3.0;
expn = 2.0;
dt   = 5.0;

mat = [emod,nue,rho0,psi0,expm,expn,dt];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% generate node points q0 and connectivity edof
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[q0,edof]=in_henry;

[nel,sizen]  = size(edof);
[ndof,sizen] = size(q0);
 
 for ie=1:nel emat(ie) = 1; end;
 
 node = ndof/2;
 nip  = 1;
 ndim = 2;
 tol  =  1e-8;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% dirichlet boundary conditions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fixing all nodes at bottom edge 47,(48),49,(69,71),72,98,101,127,128,129
bc(  1,1) = 2* 47;     bc(1,2) = 0;    % fix node  47 in y-dir
bc(  2,1) = 2* 49;     bc(2,2) = 0;    % fix node  49 in y-dir
bc(  3,1) = 2* 72;     bc(3,2) = 0;    % fix node  72 in y-dir
bc(  4,1) = 2* 98;     bc(4,2) = 0;    % fix node  98 in y-dir
bc(  5,1) = 2*101;     bc(5,2) = 0;    % fix node 101 in y-dir
bc(  6,1) = 2*127;     bc(6,2) = 0;    % fix node 127 in y-dir
bc(  7,1) = 2*128;     bc(7,2) = 0;    % fix node 128 in y-dir
bc(  8,1) = 2*129-1;   bc(8,2) = 0;    % fix node 129 in x-dir
bc(  9,1) = 2*129;     bc(9,2) = 0;    % fix node 129 in y-dir
			
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% neumann boundary conditions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
F_fac =50.d0;
F_ext = zeros(ndof,1);
F_ext(  1*2-1)=-1.0*F_fac;  F_ext(  1*2)=-1.0*F_fac; % load right most nodes
F_ext(196*2-1)=+0.5*F_fac;  F_ext(196*2)=-4.0*F_fac; % load upper most node
F_ext(302*2-1)=+0.8*F_fac;  F_ext(302*2)=-2.0*F_fac; % load an upper left node

nlod = 5;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[nmat,ngrw] = size(mat);
if (ngrw==7); disp('*** density growth ***'); end;  % density
if (ngrw==9); disp('*** volume growth ***' ); end;  % volume
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%