%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [q0,edof,emat,bc,F_ext,mat,ndim,nel,node,ndof,nip,nlod] = ex_tibia2d
% this is the input file for the final project 2d tibia model
% delta x = 111.2059
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
emod = 500;
nue  = 0.2;
rho0 = 1.00;
psi0 = 0.01;
expm = 3.0;
expn = 2.0;
dt   = 5.0;

mat = [emod,nue,rho0,psi0,expm,expn,dt];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% generate node points q0 and connectivity edof
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[q0,edof]=in_tibia2d;

[nel,sizen]  = size(edof);
[ndof,sizen] = size(q0);
 
 for ie=1:nel emat(ie) = 1; end;
 
 node = ndof/2;
 nip  = 1;
 ndim = 2;
 tol  =  1e-8;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% dirichlet boundary conditions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Henry: fixing all nodes at bottom edge in y-direction
%        also fix half the nodes in x-direction
bc(  1,1) = 2* 217-1;   bc(1,2) = 0;    % fix node 217 in x-dir
bc(  2,1) = 2* 217;     bc(2,2) = 0;    % fix node 217 in y-dir
bc(  3,1) = 2* 260-1;   bc(3,2) = 0;    % fix node 260 in x-dir
bc(  4,1) = 2* 260;     bc(4,2) = 0;    % fix node 260 in y-dir
bc(  5,1) = 2* 302-1;   bc(5,2) = 0;    % fix node 302 in x-dir
bc(  6,1) = 2* 302;     bc(6,2) = 0;    % fix node 302 in y-dir
bc(  7,1) = 2* 338-1;   bc(7,2) = 0;    % fix node 338 in x-dir
bc(  8,1) = 2* 338;     bc(8,2) = 0;    % fix node 338 in y-dir
bc(  9,1) = 2* 344-1;   bc(9,2) = 0;    % fix node 344 in x-dir
bc( 10,1) = 2* 344;     bc(10,2) = 0;   % fix node 344 in y-dir
bc( 11,1) = 2* 345;     bc(11,2) = 0;   % fix node 345 in y-dir
bc( 12,1) = 2* 357;     bc(12,2) = 0;   % fix node 357 in y-dir
bc( 13,1) = 2* 394;     bc(13,2) = 0;   % fix node 394 in y-dir
bc( 14,1) = 2* 396;     bc(14,2) = 0;   % fix node 396 in y-dir
bc( 15,1) = 2* 397;     bc(15,2) = 0;   % fix node 397 in y-dir
bc( 16,1) = 2* 398;     bc(16,2) = 0;   % fix node 398 in y-dir
bc( 17,1) = 2* 399;     bc(17,2) = 0;   % fix node 399 in y-dir
bc( 18,1) = 2* 400;     bc(18,2) = 0;   % fix node 400 in y-dir
bc( 19,1) = 2* 401;     bc(19,2) = 0;   % fix node 401 in y-dir
			
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% neumann boundary conditions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
F_fac =1000.d0; % Henry: just magnitude multipliers
F_ext = zeros(ndof,1);

% Apply at medial side and lateral side (from DEXA scan)
F_ext(439*2-1)=-0.02*F_fac; F_ext(439*2)=-0.32939*F_fac; % Medial
F_ext(870*2-1)=0.02*F_fac; F_ext(870*2)=-0.21959*F_fac; % Lateral

% Bunch of random tests here...ignore
%F_ext(439*2-1)=-0.00582*F_fac; F_ext(439*2)=-0.32939*F_fac;
%F_ext(113*2-1)=0; F_ext(113*2)=-5; %  medial force
%F_ext(870*2-1)=0.00582*F_fac; F_ext(870*2)=-0.21959*F_fac;
%F_ext(777*2-1)=0.00582*F_fac; F_ext(777*2)=-0.21959*F_fac; % lateral force
%F_ext(666*2-1)=-1; F_ext(666*2)=-5;
% F_ext(  1*2-1)=-1.0*F_fac;  F_ext(  1*2)=-1.0*F_fac; % load right most nodes
% F_ext(196*2-1)=+0.5*F_fac;  F_ext(196*2)=-4.0*F_fac; % load upper most node
% F_ext(302*2-1)=+0.8*F_fac;  F_ext(302*2)=-2.0*F_fac; % load an upper left node

nlod = 5;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[nmat,ngrw] = size(mat);
if (ngrw==7); disp('*** density growth ***'); end;  % density
if (ngrw==9); disp('*** volume growth ***' ); end;  % volume
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%