%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [q0,edof,emat,bc,F_ext,mat,ndim,nel,node,ndof,nip,nlod] = ex_tibia3d
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tol  =  1e-8;

emod = 500;
nue  = 0.3;
rho0 = 1.00;
psi0 = 0.01;
expm = 3.0;
expn = 2.0;
dt   = 5.0;

mat = [emod,nue,rho0,psi0,expm,expn,dt];
%material parameters
%emod  nue  psi0*  rho0* expm  expn   dt
%500  0.20  0.01   1.20  3.00  2.00  2.0

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% generate node points q0 and connectivity edof
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[q0,edof]=in_tibia3d; 

[nel,sizen]  = size(edof);
[ndof,sizen] = size(q0);
 for ie=1:nel emat(ie) = 1; end;

 node = ndof/3;
 nip  = 1;
 ndim = 3;
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% dirichlet and neumann boundary conditions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
%F_ext = zeros(ndof,1);
%nlod  = 3;
%% Modified by Abhishek
zmin  = min(q0(3:3:ndof)) * 0.99; % elbow side?
zmax  = max(q0(3:3:ndof)) * 1.02; % shoulder side?
ymin  = min(q0(2:3:ndof)) * 0.95; % elbow side?
ymax  = max(q0(2:3:ndof)) * 0.95; % shoulder side?
xmin  = min(q0(1:3:ndof)) *0.75+max(q0(1:3:ndof))*0.25; % elbow side?
xmax  = min(q0(1:3:ndof)) *0.25+max(q0(1:3:ndof))*0.75; % shoulder side?

zextracted=q0(3:3:ndof);
[zsorta,iza]=sort(zextracted,'ascend');
[zsortd,izd]=sort(zextracted,'descend');

yextracted=q0(2:3:ndof);
[ysort,iy]=sort(yextracted);

xextracted=q0(1:3:ndof);
[xsorta,ixa]=sort(xextracted,'ascend');
[xsortd,ixd]=sort(xextracted,'descend');

left_points=intersect(ixa(1:40),izd(1:40))
size(left_points)
right_points=intersect(ixd(1:40),izd(1:40))
size(right_points)

batonl=1;batonm=1;
for i=1:node
    if(q0(3*i-2)<=xmin && q0(3*i)>=zmax)
        lateral(batonl)=i;
        batonl=batonl+1;
    elseif(q0(3*i-2)>=xmax && q0(3*i)>=zmax)
        medial(batonm)=i;
        batonm=batonm+1;
    end
end
batonl-1
batonm-1
% Now find points at extremities

% nb    = 1;

% for nfix=3:3:ndof
%   if(q0(nfix)<=zmin) 
%       if(nb==1)
%    bc(nb,1) = nfix-2;
%    bc(nb,2) = 0;
%    nb = nb+1;
%       end
%    bc(nb,1) = nfix-1;
%    bc(nb,2) = 0;
%    nb = nb+1;
%    bc(nb,1) = nfix;
%    bc(nb,2) = 0;
%    nb = nb+1;
% % 	disp(['*** elbow node: ',num2str((nfix+1)/3)]);  	
%   end  
% end
% size(bc)
%% End of Modified by Abhishek

% for nfix=2:3:ndof
%   if(q0(nfix)>=ymax)     
%    bc(nb,1) = nfix-1;
%    bc(nb,2) = 0;
%    nb = nb+1;
%    bc(nb,1) = nfix;
%    bc(nb,2) = 0;
%    nb = nb+1;
%    bc(nb,1) = nfix+1;
%    bc(nb,2) = 0;
%    nb = nb+1;
%	disp(['*** sholder node: ',num2str((nfix+1)/3)]);  	
%   end  
% end

%for nfor=2:3:ndof
%  if(q0(nfor)<=ymin)
%    bc(nb,1) = nfor;
%    bc(nb,2) = 0.01*ymin; 
%    nb = nb+1;
%%%	F_ext(nfor,1)=-0.001;
%  end    
%end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
 fixnod=[6;9;11;12;13;14;15;16;17;18;22;23;25;39;126;138;141;143;145;149;151;152;153;158;159;160;161];              % shoulder
%fixnod=[9;
%    14;
%    12;
%   143;
%   145;
%   141;
%    15;
%   152;
%    39;
%   150;
%   147;
%   126;
%     6;
%    25;
%   151;
%   149;
%   153;
%    17;
%    13;
%   160;
%   158;
%    18;
%   138;
%   161;
%   159;
%    16;
%    23;
%    22]; %% List of all the nodes that are fixed
	[sizerow,sizecol]=size(fixnod);	
nb = 1;
for i=1:sizerow   %% This just stores what degrees of freedom are fixed (0) in a matrix of bcs 1st column stores the node number and 2nd column stores the compatibility condition (the displacement)
    nd=fixnod(i);
    if(nb==1)
    bc(nb,1) = nd*3-2;
    bc(nb,2) = 0;
    nb = nb+1;
    end
    bc(nb,1) = nd*3-1;
    bc(nb,2) = 0;
    nb = nb+1;
    bc(nb,1) = nd*3;
    bc(nb,2) = 0;
    nb = nb+1;	
end

F_ext = zeros(ndof,1);%% This is prolly stored as F1x, F1y,F1z,F2x,F2y,F2z in this order
nlod = 5;

% F0 = 0.150;
 F0 = 600;

% force on the left part 
% F_ext(306*3-2,1) =-0.1881 * F0;
%F_ext(701*3-2,1) = 0.0020;
%%F_ext(306*3-2,1) = 0.2881 * F0;
%F_ext(701*3-1,1) =0* F0;
%F_ext(701*3-0,1) =-0.0220;

% force on the left part 
% F_ext(306*3-2,1) =-0.1881 * F0;
F_ext(702*3-2,1) = 0.0020;
%F_ext(306*3-2,1) = 0.2881 * F0;
F_ext(702*3-1,1) =0* F0;
F_ext(702*3-0,1) =-0.0220;

% force on the right part
F_ext(467*3-2,1) =-0.0030;
%F_ext(310*3-2,1) =+0.0826 * F0;
F_ext(467*3-1,1) =0* F0;
F_ext(467*3-0,1) =-0.0329;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
% points to fix on Coarse Model:  
% 184,13,3,20,55,119,151,167,171,145        <-- or any 6 of these
%
% points to fix on Fine Model: 
% 180, 515, 20, 516, 55, 106, 167, 177, 514 <-- or any 6 of these
%
% points to apply force-- apply approx 200lbs at each node
%
% towards elbow    coarse: node #306   200lb * [0.1881  0.9407  -0.2822]
% towards shoulder coarse: node #310   200lb * [0.1826  0.9129  -0.3651]
%
% towards elbow    fine:   node #446   200lb * [0.1881  0.9407  -0.2822]
% towards shoulder fine:   node #453   200lb * [0.1826  0.9129  -0.3651]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
